#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
#include "Chars.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + 3, "SCORE");
    PrintS(Vram + 9, "HI-SCORE");
    PrintS(Vram + 18, "STAGE");
    PrintByteNumber2(Vram + VramWidth + 20, CurrentStage + 1);
    PrintS(Vram+ 24, "TIME");

    if (RemainCount <= 1) {
        *(Vram + 29) = Char_Space;
        *(Vram +VramWidth + 29) = Char_Space;
    }
    else {
        *(Vram + 29) = Char_Remain;
        if (RemainCount == 1) {
            *(Vram +VramWidth + 29) = Char_Space;
        }
        else {
            PrintC(Vram +VramWidth + 29, RemainCount + ('0' - 1));
        }
    }

    PrintScore();
    PrintTime();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramWidth + 2, Score);
    PrintC(pVram, '0');

    pVram = PrintNumber5(Vram + VramWidth + 11, HiScore);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintByteNumber3(Vram + VramWidth + 25, StageTime);
}


void PrintGameOver()
{
    PrintS(Vram + VramWidth * 12 + 11, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(Vram + VramWidth * 12 + 12, "TIME UP");
}

void Title()
{
    static const byte[] TitleBytes = {
        //	C
        0x1e, 0x2c, 0x23, 0x29, 
        0x2a, 0x21, 0x1e, 0x1e, 
        0x22, 0x29, 0x1e, 0x28, 
        0x1e, 0x22, 0x23, 0x1f, 
        //	R
        0x2a, 0x25, 0x23, 0x29, 
        0x2a, 0x21, 0x26, 0x2d, 
        0x2a, 0x25, 0x2d, 0x20, 
        0x22, 0x1f, 0x22, 0x23, 
        //	A
        0x1e, 0x2c, 0x2b, 0x20, 
        0x2a, 0x21, 0x1e, 0x2d, 
        0x2a, 0x25, 0x23, 0x2d, 
        0x22, 0x1f, 0x1e, 0x23, 
        //	C
        0x1e, 0x2c, 0x23, 0x29, 
        0x2a, 0x21, 0x1e, 0x1e, 
        0x22, 0x29, 0x1e, 0x28, 
        0x1e, 0x22, 0x23, 0x1f, 
        //	K
        0x2a, 0x21, 0x26, 0x25, 
        0x2a, 0x29, 0x25, 0x1e, 
        0x2a, 0x21, 0x2b, 0x20, 
        0x22, 0x1f, 0x1e, 0x23, 
        //	Y
        0x2a, 0x21, 0x2a, 0x21, 
        0x22, 0x29, 0x2c, 0x1f, 
        0x1e, 0x2a, 0x21, 0x1e, 
        0x1e, 0x22, 0x1f, 0x1e, 
    };

    ClearScreen(); 
    HideAllSprites();
    // UpdateSprites();
    PrintStatus();
    {
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramWidth * 7 + (32 - 6 * 4) / 2;
        p = TitleBytes;
        repeat (6) {
            repeat (4) {
                repeat (4) {
                    *pVram = *p;
                    ++pVram;
                    ++p;
                }
                pVram += VramWidth - 4;
            }
            pVram += 4 - VramWidth * 4;
        }
    }
    PrintS(Vram + VramWidth * 20 + 6, "PUSH TRIGGER BUTTON");
    PrintS(Vram + VramWidth * 23 + 20 - 2, "INUFUTO 2023");
}